org.apache.lucene.search

## Class FieldComparator.DoubleComparator

- java.lang.Object
- - org.apache.lucene.search.FieldComparator<T>
  - - org.apache.lucene.search.SimpleFieldComparator<T>
    - - org.apache.lucene.search.FieldComparator.NumericComparator<Double>
      - - org.apache.lucene.search.FieldComparator.DoubleComparator

- All Implemented Interfaces:
    LeafFieldComparator
  Enclosing class:
    FieldComparator<T>

      public static class FieldComparator.DoubleComparator
      extends FieldComparator.NumericComparator<Double>

  Parses field's values as double (using `LeafReader.getNumericDocValues(java.lang.String)` and sorts by ascending value

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.search.FieldComparator

      `FieldComparator.DocComparator, FieldComparator.DoubleComparator, FieldComparator.FloatComparator, FieldComparator.IntComparator, FieldComparator.LongComparator, FieldComparator.NumericComparator<T extends Number>, FieldComparator.RelevanceComparator, FieldComparator.TermOrdValComparator, FieldComparator.TermValComparator`

  - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.search.FieldComparator.NumericComparator

      `currentReaderValues, field, missingValue`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DoubleComparator(int numHits, String field, Double missingValue)` Creates a new comparator based on `Double.compare(double, double)` for `numHits`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compare(int slot1, int slot2)` Compare hit at slot1 with hit at slot2.
    `int` | `compareBottom(int doc)` Compare the bottom of the queue with this doc.
    `int` | `compareTop(int doc)` Compare the top value with this doc.
    `void` | `copy(int slot, int doc)` This method is called when a new hit is competitive.
    `void` | `setBottom(int bottom)` Set the bottom slot, ie the "weakest" (sorted last) entry in the queue.
    `void` | `setTopValue(Double value)` Record the top value, for future calls to `LeafFieldComparator.compareTop(int)`.
    `Double` | `value(int slot)` Return the actual value in the slot.

    - ### Methods inherited from class org.apache.lucene.search.FieldComparator.NumericComparator

      `doSetNextReader, getNumericDocValues`

    - ### Methods inherited from class org.apache.lucene.search.SimpleFieldComparator

      `getLeafComparator, setScorer`

    - ### Methods inherited from class org.apache.lucene.search.FieldComparator

      `compareValues`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DoubleComparator

          public DoubleComparator(int numHits,
                                  String field,
                                  Double missingValue)

      Creates a new comparator based on `Double.compare(double, double)` for `numHits`. When a document has no value for the field, `missingValue` is substituted.

  - ### Method Detail

    - #### compare

          public int compare(int slot1,
                             int slot2)

      Description copied from class: `FieldComparator`
      Compare hit at slot1 with hit at slot2.
      Specified by:
        `compare` in class `FieldComparator<Double>`
      Parameters:
        `slot1` - first slot to compare
        `slot2` - second slot to compare
      Returns:
        any `N < 0` if slot2's value is sorted after slot1, any `N > 0` if the slot2's value is sorted before slot1 and `0` if they are equal

    - #### compareBottom

          public int compareBottom(int doc)
                            throws IOException

      Description copied from interface: `LeafFieldComparator`
      Compare the bottom of the queue with this doc. This will only invoked after setBottom has been called. This should return the same result as `FieldComparator.compare(int,int)`} as if bottom were slot1 and the new document were slot 2.

      For a search that hits many results, this method will be the hotspot (invoked by far the most frequently).

      Parameters:
        `doc` - that was hit
      Returns:
        any `N < 0` if the doc's value is sorted after the bottom entry (not competitive), any `N > 0` if the doc's value is sorted before the bottom entry and `0` if they are equal.
      Throws:
        `IOException`

    - #### copy

          public void copy(int slot,
                           int doc)
                    throws IOException

      Description copied from interface: `LeafFieldComparator`
      This method is called when a new hit is competitive. You should copy any state associated with this document that will be required for future comparisons, into the specified slot.
      Parameters:
        `slot` - which slot to copy the hit to
        `doc` - docID relative to current reader
      Throws:
        `IOException`

    - #### setBottom

          public void setBottom(int bottom)

      Description copied from interface: `LeafFieldComparator`
      Set the bottom slot, ie the "weakest" (sorted last) entry in the queue. When `LeafFieldComparator.compareBottom(int)` is called, you should compare against this slot. This will always be called before `LeafFieldComparator.compareBottom(int)`.
      Parameters:
        `bottom` - the currently weakest (sorted last) slot in the queue

    - #### setTopValue

          public void setTopValue(Double value)

      Description copied from class: `FieldComparator`
      Record the top value, for future calls to `LeafFieldComparator.compareTop(int)`. This is only called for searches that use searchAfter (deep paging), and is called before any calls to `FieldComparator.getLeafComparator(LeafReaderContext)`.
      Specified by:
        `setTopValue` in class `FieldComparator<Double>`

    - #### value

          public Double value(int slot)

      Description copied from class: `FieldComparator`
      Return the actual value in the slot.
      Specified by:
        `value` in class `FieldComparator<Double>`
      Parameters:
        `slot` - the value
      Returns:
        value in this slot

    - #### compareTop

          public int compareTop(int doc)
                         throws IOException

      Description copied from interface: `LeafFieldComparator`
      Compare the top value with this doc. This will only invoked after setTopValue has been called. This should return the same result as `FieldComparator.compare(int,int)`} as if topValue were slot1 and the new document were slot 2. This is only called for searches that use searchAfter (deep paging).
      Parameters:
        `doc` - that was hit
      Returns:
        any `N < 0` if the doc's value is sorted after the top entry (not competitive), any `N > 0` if the doc's value is sorted before the top entry and `0` if they are equal.
      Throws:
        `IOException`

Copyright © 2000-2019 Apache Software Foundation. All Rights Reserved.